// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Batch.Protocol.Models
{
    using System.Linq;

    /// <summary>
    /// The network configuration for a pool.
    /// </summary>
    public partial class NetworkConfiguration
    {
        /// <summary>
        /// Initializes a new instance of the NetworkConfiguration class.
        /// </summary>
        public NetworkConfiguration() { }

        /// <summary>
        /// Initializes a new instance of the NetworkConfiguration class.
        /// </summary>
        /// <param name="subnetId">The ARM resource identifier of the virtual
        /// network subnet which the compute nodes of the pool will join. The
        /// virtual network must be in the same region and subscription as
        /// the Azure Batch account. This property can only be specified for
        /// pools created with a cloudServiceConfiguration.</param>
        public NetworkConfiguration(string subnetId = default(string))
        {
            SubnetId = subnetId;
        }

        /// <summary>
        /// Gets or sets the ARM resource identifier of the virtual network
        /// subnet which the compute nodes of the pool will join. The virtual
        /// network must be in the same region and subscription as the Azure
        /// Batch account. This property can only be specified for pools
        /// created with a cloudServiceConfiguration.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "subnetId")]
        public string SubnetId { get; set; }

    }
}
