// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DevTestLabs.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Parameters for generating an ARM template for deploying artifacts.
    /// </summary>
    public partial class GenerateArmTemplateRequest
    {
        /// <summary>
        /// Initializes a new instance of the GenerateArmTemplateRequest class.
        /// </summary>
        public GenerateArmTemplateRequest() { }

        /// <summary>
        /// Initializes a new instance of the GenerateArmTemplateRequest class.
        /// </summary>
        public GenerateArmTemplateRequest(string virtualMachineName = default(string), IList<ParameterInfo> parameters = default(IList<ParameterInfo>), string location = default(string))
        {
            VirtualMachineName = virtualMachineName;
            Parameters = parameters;
            Location = location;
        }

        /// <summary>
        /// The resource name of the virtual machine.
        /// </summary>
        [JsonProperty(PropertyName = "virtualMachineName")]
        public string VirtualMachineName { get; set; }

        /// <summary>
        /// The parameters of the ARM template.
        /// </summary>
        [JsonProperty(PropertyName = "parameters")]
        public IList<ParameterInfo> Parameters { get; set; }

        /// <summary>
        /// The location of the virtual machine.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

    }
}
