// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Insights.Models
{
    using System.Linq;

    /// <summary>
    /// The scheduling constraints for when the profile begins.
    /// </summary>
    public partial class RecurrentSchedule
    {
        /// <summary>
        /// Initializes a new instance of the RecurrentSchedule class.
        /// </summary>
        public RecurrentSchedule() { }

        /// <summary>
        /// Initializes a new instance of the RecurrentSchedule class.
        /// </summary>
        /// <param name="timeZone">the time zone for the hours of the profile.
        /// See examples of valid timezone ids over here:
        /// https://msdn.microsoft.com/en-us/library/azure/dn931928.aspx</param>
        /// <param name="days">the collection of days that the profile takes
        /// effect on. Possible values are Sunday through Saturday.</param>
        /// <param name="hours">A collection of hours that the profile takes
        /// effect on. Values supported are 0 to 23 on the 24-hour clock
        /// (AM/PM times are not supported).</param>
        /// <param name="minutes">A collection of minutes at which the profile
        /// takes effect at.</param>
        public RecurrentSchedule(string timeZone = default(string), System.Collections.Generic.IList<string> days = default(System.Collections.Generic.IList<string>), System.Collections.Generic.IList<int?> hours = default(System.Collections.Generic.IList<int?>), System.Collections.Generic.IList<int?> minutes = default(System.Collections.Generic.IList<int?>))
        {
            TimeZone = timeZone;
            Days = days;
            Hours = hours;
            Minutes = minutes;
        }

        /// <summary>
        /// Gets or sets the time zone for the hours of the profile. See
        /// examples of valid timezone ids over here:
        /// https://msdn.microsoft.com/en-us/library/azure/dn931928.aspx
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "timeZone")]
        public string TimeZone { get; set; }

        /// <summary>
        /// Gets or sets the collection of days that the profile takes effect
        /// on. Possible values are Sunday through Saturday.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "days")]
        public System.Collections.Generic.IList<string> Days { get; set; }

        /// <summary>
        /// Gets or sets a collection of hours that the profile takes effect
        /// on. Values supported are 0 to 23 on the 24-hour clock (AM/PM
        /// times are not supported).
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "hours")]
        public System.Collections.Generic.IList<int?> Hours { get; set; }

        /// <summary>
        /// Gets or sets a collection of minutes at which the profile takes
        /// effect at.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "minutes")]
        public System.Collections.Generic.IList<int?> Minutes { get; set; }

    }
}
