// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.KeyVault.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Permissions the identity has for keys, secrets and certificates.
    /// </summary>
    public partial class Permissions
    {
        /// <summary>
        /// Initializes a new instance of the Permissions class.
        /// </summary>
        public Permissions() { }

        /// <summary>
        /// Initializes a new instance of the Permissions class.
        /// </summary>
        /// <param name="keys">Permissions to keys</param>
        /// <param name="secrets">Permissions to secrets</param>
        /// <param name="certificates">Permissions to certificates</param>
        public Permissions(IList<string> keys = default(IList<string>), IList<string> secrets = default(IList<string>), IList<string> certificates = default(IList<string>))
        {
            Keys = keys;
            Secrets = secrets;
            Certificates = certificates;
        }

        /// <summary>
        /// Gets or sets permissions to keys
        /// </summary>
        [JsonProperty(PropertyName = "keys")]
        public IList<string> Keys { get; set; }

        /// <summary>
        /// Gets or sets permissions to secrets
        /// </summary>
        [JsonProperty(PropertyName = "secrets")]
        public IList<string> Secrets { get; set; }

        /// <summary>
        /// Gets or sets permissions to certificates
        /// </summary>
        [JsonProperty(PropertyName = "certificates")]
        public IList<string> Certificates { get; set; }

    }
}
