// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.CommitmentPlans.Models
{
    using System.Linq;

    /// <summary>
    /// The properties of a commitment plan which may be updated via PATCH.
    /// </summary>
    public partial class CommitmentPlanPatchPayload
    {
        /// <summary>
        /// Initializes a new instance of the CommitmentPlanPatchPayload class.
        /// </summary>
        public CommitmentPlanPatchPayload() { }

        /// <summary>
        /// Initializes a new instance of the CommitmentPlanPatchPayload class.
        /// </summary>
        /// <param name="tags">User-defined tags for the commitment
        /// plan.</param>
        /// <param name="sku">The commitment plan SKU.</param>
        public CommitmentPlanPatchPayload(System.Collections.Generic.IDictionary<string, string> tags = default(System.Collections.Generic.IDictionary<string, string>), ResourceSku sku = default(ResourceSku))
        {
            Tags = tags;
            Sku = sku;
        }

        /// <summary>
        /// Gets or sets user-defined tags for the commitment plan.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "tags")]
        public System.Collections.Generic.IDictionary<string, string> Tags { get; set; }

        /// <summary>
        /// Gets or sets the commitment plan SKU.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "sku")]
        public ResourceSku Sku { get; set; }

    }
}
