// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.WebServices.Models
{
    using System.Linq;

    /// <summary>
    /// Information about the machine learning workspace containing the
    /// experiment that is source for the web service.
    /// </summary>
    public partial class MachineLearningWorkspace
    {
        /// <summary>
        /// Initializes a new instance of the MachineLearningWorkspace class.
        /// </summary>
        public MachineLearningWorkspace() { }

        /// <summary>
        /// Initializes a new instance of the MachineLearningWorkspace class.
        /// </summary>
        /// <param name="id">The workspace ARM resource id.</param>
        public MachineLearningWorkspace(string id)
        {
            Id = id;
        }

        /// <summary>
        /// Gets or sets the workspace ARM resource id.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Id == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "Id");
            }
        }
    }
}
