// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.ResourceManager.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Subscription information.
    /// </summary>
    public partial class Subscription
    {
        /// <summary>
        /// Initializes a new instance of the Subscription class.
        /// </summary>
        public Subscription() { }

        /// <summary>
        /// Initializes a new instance of the Subscription class.
        /// </summary>
        /// <param name="id">The ID of the resource (/subscriptions/SubscriptionId).</param>
        /// <param name="subscriptionId">The subscription Id.</param>
        /// <param name="tenantId">The tenant Id.</param>
        /// <param name="displayName">The subscription display name.</param>
        /// <param name="state">The subscription state.</param>
        /// <param name="subscriptionPolicies">The subscription policies.</param>
        /// <param name="authorizationSource">The authorization source of the request. Valid values are one or more combinations of Legacy, RoleBased, Bypassed, Direct and Management. For example, 'Legacy, RoleBased'.</param>
        public Subscription(string id = default(string), string subscriptionId = default(string), string tenantId = default(string), string displayName = default(string), string state = default(string), SubscriptionPolicies subscriptionPolicies = default(SubscriptionPolicies), string authorizationSource = default(string))
        {
            Id = id;
            SubscriptionId = subscriptionId;
            TenantId = tenantId;
            DisplayName = displayName;
            State = state;
            SubscriptionPolicies = subscriptionPolicies;
            AuthorizationSource = authorizationSource;
        }

        /// <summary>
        /// Gets or sets the ID of the resource
        /// (/subscriptions/SubscriptionId).
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the subscription Id.
        /// </summary>
        [JsonProperty(PropertyName = "subscriptionId")]
        public string SubscriptionId { get; set; }

        /// <summary>
        /// Gets or sets the tenant Id.
        /// </summary>
        [JsonProperty(PropertyName = "tenantId")]
        public string TenantId { get; set; }

        /// <summary>
        /// Gets or sets the subscription display name.
        /// </summary>
        [JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets the subscription state.
        /// </summary>
        [JsonProperty(PropertyName = "state")]
        public string State { get; set; }

        /// <summary>
        /// Gets or sets the subscription policies.
        /// </summary>
        [JsonProperty(PropertyName = "subscriptionPolicies")]
        public SubscriptionPolicies SubscriptionPolicies { get; set; }

        /// <summary>
        /// Gets or sets the authorization source of the request. Valid values
        /// are one or more combinations of Legacy, RoleBased, Bypassed,
        /// Direct and Management. For example, 'Legacy, RoleBased'.
        /// </summary>
        [JsonProperty(PropertyName = "authorizationSource")]
        public string AuthorizationSource { get; set; }

    }
}
