// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites
{
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;

    public static partial class ManagedHostingEnvironmentsOperationsExtensions
    {
            /// <summary>
            /// Get properties of a managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            public static ManagedHostingEnvironment GetManagedHostingEnvironment(this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name)
            {
                return Task.Factory.StartNew(s => ((IManagedHostingEnvironmentsOperations)s).GetManagedHostingEnvironmentAsync(resourceGroupName, name), operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get properties of a managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ManagedHostingEnvironment> GetManagedHostingEnvironmentAsync( this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetManagedHostingEnvironmentWithHttpMessagesAsync(resourceGroupName, name, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Create or update a managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            /// <param name='managedHostingEnvironmentEnvelope'>
            /// Properties of managed hosting environment
            /// </param>
            public static HostingEnvironment CreateOrUpdateManagedHostingEnvironment(this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name, HostingEnvironment managedHostingEnvironmentEnvelope)
            {
                return Task.Factory.StartNew(s => ((IManagedHostingEnvironmentsOperations)s).CreateOrUpdateManagedHostingEnvironmentAsync(resourceGroupName, name, managedHostingEnvironmentEnvelope), operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Create or update a managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            /// <param name='managedHostingEnvironmentEnvelope'>
            /// Properties of managed hosting environment
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<HostingEnvironment> CreateOrUpdateManagedHostingEnvironmentAsync( this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name, HostingEnvironment managedHostingEnvironmentEnvelope, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateManagedHostingEnvironmentWithHttpMessagesAsync(resourceGroupName, name, managedHostingEnvironmentEnvelope, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Create or update a managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            /// <param name='managedHostingEnvironmentEnvelope'>
            /// Properties of managed hosting environment
            /// </param>
            public static HostingEnvironment BeginCreateOrUpdateManagedHostingEnvironment(this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name, HostingEnvironment managedHostingEnvironmentEnvelope)
            {
                return Task.Factory.StartNew(s => ((IManagedHostingEnvironmentsOperations)s).BeginCreateOrUpdateManagedHostingEnvironmentAsync(resourceGroupName, name, managedHostingEnvironmentEnvelope), operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Create or update a managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            /// <param name='managedHostingEnvironmentEnvelope'>
            /// Properties of managed hosting environment
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<HostingEnvironment> BeginCreateOrUpdateManagedHostingEnvironmentAsync( this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name, HostingEnvironment managedHostingEnvironmentEnvelope, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginCreateOrUpdateManagedHostingEnvironmentWithHttpMessagesAsync(resourceGroupName, name, managedHostingEnvironmentEnvelope, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Delete a managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            /// <param name='forceDelete'>
            /// Delete even if the managed hosting environment contains resources
            /// </param>
            public static object DeleteManagedHostingEnvironment(this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name, bool? forceDelete = default(bool?))
            {
                return Task.Factory.StartNew(s => ((IManagedHostingEnvironmentsOperations)s).DeleteManagedHostingEnvironmentAsync(resourceGroupName, name, forceDelete), operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Delete a managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            /// <param name='forceDelete'>
            /// Delete even if the managed hosting environment contains resources
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> DeleteManagedHostingEnvironmentAsync( this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name, bool? forceDelete = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.DeleteManagedHostingEnvironmentWithHttpMessagesAsync(resourceGroupName, name, forceDelete, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Delete a managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            /// <param name='forceDelete'>
            /// Delete even if the managed hosting environment contains resources
            /// </param>
            public static object BeginDeleteManagedHostingEnvironment(this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name, bool? forceDelete = default(bool?))
            {
                return Task.Factory.StartNew(s => ((IManagedHostingEnvironmentsOperations)s).BeginDeleteManagedHostingEnvironmentAsync(resourceGroupName, name, forceDelete), operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Delete a managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            /// <param name='forceDelete'>
            /// Delete even if the managed hosting environment contains resources
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> BeginDeleteManagedHostingEnvironmentAsync( this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name, bool? forceDelete = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.BeginDeleteManagedHostingEnvironmentWithHttpMessagesAsync(resourceGroupName, name, forceDelete, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get all managed hosting environments in a resource group.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            public static HostingEnvironmentCollection GetManagedHostingEnvironments(this IManagedHostingEnvironmentsOperations operations, string resourceGroupName)
            {
                return Task.Factory.StartNew(s => ((IManagedHostingEnvironmentsOperations)s).GetManagedHostingEnvironmentsAsync(resourceGroupName), operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get all managed hosting environments in a resource group.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<HostingEnvironmentCollection> GetManagedHostingEnvironmentsAsync( this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetManagedHostingEnvironmentsWithHttpMessagesAsync(resourceGroupName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get list of ip addresses assigned to a managed hosting environment
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            public static AddressResponse GetManagedHostingEnvironmentVips(this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name)
            {
                return Task.Factory.StartNew(s => ((IManagedHostingEnvironmentsOperations)s).GetManagedHostingEnvironmentVipsAsync(resourceGroupName, name), operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get list of ip addresses assigned to a managed hosting environment
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<AddressResponse> GetManagedHostingEnvironmentVipsAsync( this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetManagedHostingEnvironmentVipsWithHttpMessagesAsync(resourceGroupName, name, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get status of an operation on a managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            /// <param name='operationId'>
            /// operation identifier GUID
            /// </param>
            public static object GetManagedHostingEnvironmentOperation(this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name, string operationId)
            {
                return Task.Factory.StartNew(s => ((IManagedHostingEnvironmentsOperations)s).GetManagedHostingEnvironmentOperationAsync(resourceGroupName, name, operationId), operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get status of an operation on a managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            /// <param name='operationId'>
            /// operation identifier GUID
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> GetManagedHostingEnvironmentOperationAsync( this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name, string operationId, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetManagedHostingEnvironmentOperationWithHttpMessagesAsync(resourceGroupName, name, operationId, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get all sites on the managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            /// <param name='propertiesToInclude'>
            /// Comma separated list of site properties to include
            /// </param>
            public static SiteCollection GetManagedHostingEnvironmentSites(this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name, string propertiesToInclude = default(string))
            {
                return Task.Factory.StartNew(s => ((IManagedHostingEnvironmentsOperations)s).GetManagedHostingEnvironmentSitesAsync(resourceGroupName, name, propertiesToInclude), operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get all sites on the managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            /// <param name='propertiesToInclude'>
            /// Comma separated list of site properties to include
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<SiteCollection> GetManagedHostingEnvironmentSitesAsync( this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name, string propertiesToInclude = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetManagedHostingEnvironmentSitesWithHttpMessagesAsync(resourceGroupName, name, propertiesToInclude, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get all serverfarms (App Service Plans) on the managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            public static ServerFarmCollection GetManagedHostingEnvironmentWebHostingPlans(this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name)
            {
                return Task.Factory.StartNew(s => ((IManagedHostingEnvironmentsOperations)s).GetManagedHostingEnvironmentWebHostingPlansAsync(resourceGroupName, name), operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get all serverfarms (App Service Plans) on the managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ServerFarmCollection> GetManagedHostingEnvironmentWebHostingPlansAsync( this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetManagedHostingEnvironmentWebHostingPlansWithHttpMessagesAsync(resourceGroupName, name, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get all serverfarms (App Service Plans) on the managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            public static ServerFarmCollection GetManagedHostingEnvironmentServerFarms(this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name)
            {
                return Task.Factory.StartNew(s => ((IManagedHostingEnvironmentsOperations)s).GetManagedHostingEnvironmentServerFarmsAsync(resourceGroupName, name), operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get all serverfarms (App Service Plans) on the managed hosting environment.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// Name of resource group
            /// </param>
            /// <param name='name'>
            /// Name of managed hosting environment
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ServerFarmCollection> GetManagedHostingEnvironmentServerFarmsAsync( this IManagedHostingEnvironmentsOperations operations, string resourceGroupName, string name, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetManagedHostingEnvironmentServerFarmsWithHttpMessagesAsync(resourceGroupName, name, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
