// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Http logs configuration
    /// </summary>
    public partial class HttpLogsConfig
    {
        /// <summary>
        /// Initializes a new instance of the HttpLogsConfig class.
        /// </summary>
        public HttpLogsConfig() { }

        /// <summary>
        /// Initializes a new instance of the HttpLogsConfig class.
        /// </summary>
        public HttpLogsConfig(FileSystemHttpLogsConfig fileSystem = default(FileSystemHttpLogsConfig), AzureBlobStorageHttpLogsConfig azureBlobStorage = default(AzureBlobStorageHttpLogsConfig))
        {
            FileSystem = fileSystem;
            AzureBlobStorage = azureBlobStorage;
        }

        /// <summary>
        /// Http logs to file system configuration
        /// </summary>
        [JsonProperty(PropertyName = "fileSystem")]
        public FileSystemHttpLogsConfig FileSystem { get; set; }

        /// <summary>
        /// Http logs to azure blob storage configuration
        /// </summary>
        [JsonProperty(PropertyName = "azureBlobStorage")]
        public AzureBlobStorageHttpLogsConfig AzureBlobStorage { get; set; }

    }
}
