// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Search.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Represents information about the entity (such as Azure SQL table or
    /// DocumentDb collection) that will be indexed.
    /// </summary>
    public partial class DataContainer
    {
        /// <summary>
        /// Initializes a new instance of the DataContainer class.
        /// </summary>
        public DataContainer() { }

        /// <summary>
        /// Initializes a new instance of the DataContainer class.
        /// </summary>
        public DataContainer(string name, string query = default(string))
        {
            Name = name;
            Query = query;
        }

        /// <summary>
        /// Gets or sets the name of the table or view (for Azure SQL data
        /// source) or collection (for DocumentDB data source) that will be
        /// indexed.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets a query that is applied to this data container. The
        /// syntax and meaning of this parameter is datasource-specific. Not
        /// supported by Azure SQL datasources.
        /// </summary>
        [JsonProperty(PropertyName = "query")]
        public string Query { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
        }
    }
}
